\section{Experiments}

\begin{frame}{Experimental Setup Summary}
    % Diagram || Details
    \begin{itemize}
        \item Same datasets as \cite{Ren2020}: FB15k, FB15k-237, and NELL-995
        \item Use generated ``complex'' queries from~\cite{Ren2020}  
        \item Train KGEs for link prediction (atomic queries)
        \item Evaluate CQD on the complex queries
    \end{itemize}
\end{frame} 

\begin{frame}{Datasets~\cite{Ren2020}}
    \begin{table}[]
        \centering
        \begin{tabular}{@{}lrrrrrr@{}}
            \toprule
            Dataset   & \(|\entspace|\) & \(|\relspace|\) & \begin{tabular}[c]{@{}r@{}}Train.\\ Edges\end{tabular} & \begin{tabular}[c]{@{}r@{}}Valid.\\ Edges\end{tabular} & \begin{tabular}[c]{@{}r@{}}Test\\ Edges\end{tabular} & \begin{tabular}[c]{@{}r@{}}Total\\ Edges\end{tabular} \\ \midrule
            FB15k     & 14951           & 1345            & 483142                                                   & 50000                                                      & 59071                                                & 592213                                                \\
            FB15k-237 & 14505           & 237             & 272115                                                   & 17526                                                      & 20438                                                & 310079                                                \\
            NELL995   & 63361           & 200             & 114213                                                   & 14324                                                      & 14267                                                & 142804                                                \\ \bottomrule
        \end{tabular}
    \end{table}

    \begin{itemize}[itemsep=1pt]
        \item KGs augmented with inverse relations \((King, wrote, It) \rightarrow (It, hasAuthor, King)\)
        \item \(\mathcal{G}_{train} \subseteq \mathcal{G}_{valid} \subseteq \mathcal{G}_{test}\)
    \end{itemize}
\end{frame}

\begin{frame}{Types of Query}
    \begin{figure}
        \begin{subfigure}{0.3\textwidth}
            \centering{\input{1p.tex}}
            \caption*{1p}
        \end{subfigure}\hfill
        \begin{subfigure}{0.3\textwidth}
            \centering{\input{2p.tex}}
            \caption*{2p}
        \end{subfigure}\hfill
        \begin{subfigure}{0.3\textwidth}
            \centering{\input{3p.tex}}
            \caption*{3p}
        \end{subfigure}

        \begin{subfigure}{0.3\textwidth}
            \centering{\input{2i.tex}}
            \caption*{2i}
        \end{subfigure}\hfill
        \begin{subfigure}{0.3\textwidth}
            \centering{\input{3i.tex}}
            \caption*{3i}
        \end{subfigure}\hfill
        \begin{subfigure}{0.3\textwidth}
            \centering{\input{pi.tex}}
            \caption*{pi}
        \end{subfigure}

        \begin{subfigure}{0.3\textwidth}
            \centering{\input{ip.tex}}
            \caption*{ip}
        \end{subfigure}\hfill
        \begin{subfigure}{0.3\textwidth}
            \centering{\input{up.tex}}
            \caption*{up}
        \end{subfigure}\hfill
        \begin{subfigure}{0.3\textwidth}
            \centering{\input{2u.tex}}
            \caption*{2u}
        \end{subfigure}
        \caption*{Queries using (p)rojection, (i)ntersection, and (u)nion}
    \end{figure}
\end{frame}

\begin{frame}{Query Generation~\cite{Ren2020}}

    \begin{itemize}[itemsep=2pt]
        \item Select random entities as anchors
        \item Match the query graph with the KG to find suitable replacements
        \item Remove degenerated queries 
        \item Remove trivial queries that can be fully answered by subgraph matching on training edges only\footnote{Done in~\cite{Ren2020}}
    \end{itemize}

\end{frame}

\begin{frame}{Query Dataset~\cite{Ren2020}}
    \begin{table}[]
        \centering
        \begin{tabular}{@{}lrrrrrr@{}}
            \toprule
            \multirow{2}{*}{Dataset} & \multicolumn{2}{c}{Training} & \multicolumn{2}{c}{Validation} & \multicolumn{2}{c}{Test} \\
                                     & 1p            & Others       & 1p            & Others         & 1p         & Others      \\ \midrule
            FB15k                    & 273710        & 273710       & 59097         & 8000           & 67916      & 8000        \\
            FB15k-237                & 149689        & 149689       & 20101         & 5000           & 22812      & 5000        \\
            NELL995                  & 107982        & 107982       & 16927         & 4000           & 17034      & 4000        \\ \bottomrule
        \end{tabular}
    \end{table}
    
    % Note: too many 1p -> improvement over Q2B even for those
\end{frame}

\begin{frame}{Filtered Hits@3 Results}
% Please add the following required packages to your document preamble:
% \usepackage{booktabs}
% \usepackage{graphicx}
    \begin{table}[]
        \centering
        \resizebox{\textwidth}{!}{%
            \begin{tabular}{@{}lrrrrrrrrrr@{}}
                \toprule
                Method    & Avg            & 1p             & 2p             & 3p             & 2i             & 3i             & ip             & pi             & 2u             & up             \\ \midrule
                \multicolumn{11}{c}{FB15k}                                                                                                                                                          \\ \midrule
                GQE       & 0.384          & 0.630          & 0.346          & 0.250          & 0.515          & 0.611          & 0.153          & 0.320          & 0.362          & 0.271          \\
                Query2Box & 0.484          & 0.786          & 0.413          & 0.303          & 0.593          & 0.712          & 0.211          & 0.397          & 0.608          & 0.330          \\
                CQD-CO    & 0.576          & \textbf{0.918} & 0.454          & 0.191          & \textbf{0.796} & \textbf{0.837} & 0.336          & 0.513          & 0.816          & 0.319          \\
                CQD-Beam  & \textbf{0.680} & \textbf{0.918} & \textbf{0.779} & \textbf{0.577} & \textbf{0.796} & \textbf{0.837} & \textbf{0.375} & \textbf{0.658} & \textbf{0.839} & \textbf{0.345} \\ \midrule
                \multicolumn{11}{c}{FB15k-237}                                                                                                                                                      \\ \midrule
                GQE       & 0.230          & 0.405          & 0.213          & 0.153          & 0.298          & 0.411          & 0.085          & 0.182          & 0.167          & 0.160          \\
                Query2Box & 0.268          & 0.467          & 0.240          & 0.186          & 0.324          & 0.453          & 0.108          & 0.205          & 0.239          & \textbf{0.193} \\
                CQD-CO    & 0.272          & \textbf{0.512} & 0.213          & 0.131          & \textbf{0.352} & \textbf{0.457} & \textbf{0.146} & 0.222          & 0.281          & 0.132          \\
                CQD-Beam  & \textbf{0.290} & \textbf{0.512} & \textbf{0.288} & \textbf{0.221} & \textbf{0.352} & \textbf{0.457} & 0.129          & \textbf{0.249} & \textbf{0.284} & 0.121          \\ \midrule
                \multicolumn{11}{c}{NELL995}                                                                                                                                                        \\ \midrule
                GQE       & 0.248          & 0.417          & 0.231          & 0.203          & 0.318          & 0.454          & 0.081          & 0.188          & 0.200          & 0.139          \\
                Query2Box & 0.306          & 0.555          & 0.266          & 0.233          & 0.343          & 0.480          & 0.132          & 0.212          & 0.369          & 0.163          \\
                CQD-CO    & 0.368          & \textbf{0.667} & 0.265          & 0.220          & \textbf{0.410} & \textbf{0.529} & \textbf{0.196} & \textbf{0.302} & \textbf{0.531} & \textbf{0.194} \\
                CQD-Beam  & \textbf{0.375} & \textbf{0.667} & \textbf{0.350} & \textbf{0.288} & \textbf{0.410} & \textbf{0.529} & 0.171          & 0.277          & \textbf{0.531} & 0.156          \\ \bottomrule
            \end{tabular}%
        }
    \end{table}
\end{frame}

\begin{frame}{MRR Results}
    Check \href{https://paperswithcode.com/sota/complex-query-answering-on-fb15k?p=complex-query-answering-with-neural-link-1}{SOTA at Papers with Code for Query Answering on KGs} 
\end{frame}
